import pygame
import math
import sys
pygame.init()

WINDOW_SIZE = (1280, 720)
WINDOW_TITLE = "Pygame Tutorial"

FRAME_RATE = 60
ANIMATION_FRAME_RATE = 20
WINDOW = pygame.display.set_mode(WINDOW_SIZE)
pygame.display.set_caption(WINDOW_TITLE)
CLOCK = pygame.time.Clock()
background = pygame.transform.scale(pygame.image.load("assets/map.png"), WINDOW_SIZE)

HORIZONTAL = 1
UP = 2
DOWN = 0
BLACK = (0,0,0)
BOUNDS_X = (60, 1220)
BOUNDS_Y = (60, 680)
SPEED = 1.3

moving_left = False
moving_right = False
moving_up = False
moving_down = False
obj_all = []
env_all = []
repels = 0
obj = 2
# class for helping generate the environment
class Environment:
    def __init__(self, x, y, width, height):
        self.rect = pygame.Rect(x, y, width, height)
        env_all.append(self.rect)      
        
SURFACE_COLOR = (167, 255, 100)
COLOR = (255, 100, 98)
white = (0,0,0)
RED = (255, 0, 0)

class Sprite(pygame.sprite.Sprite): 
    def __init__(self, color, height, width): 
        super().__init__()
        self.image = pygame.image.load("assets/Obj_2.png")
        self.surf = pygame.image.load("assets/Obj_1.png").convert()
        self.rect = self.surf.get_rect()
        
    def update(self):
        global obj
        global repels
        WINDOW.blit(self.image, self.rect)
        if self.rect.colliderect(player.x, player.y, player.width, player.height):
            self.kill()
            obj -=1
            repels +=1
            
#environment objects
t1 = Environment(840, 380, 160, 180)
t2 = Environment(1040, 380, 110, 180)
t3 = Environment(540, 518, 175, 161)
t4 = Environment(140, 537, 320, 23)
t5 = Environment(140, 460, 40, 80)
t6 = Environment(174, 460, 30, 19)
t7 = Environment(240, 380, 220, 97)
t8 = Environment(0, 20, 60, 1220)
t9 = Environment(0, 0, 1220, 20)
t0 = Environment(1220,0,60,780)
t11 = Environment(60,660,1220,60)
t12 = Environment(60, 380, 140, 12)
t13 = Environment(60, 320, 299, 2)
t14 = Environment(359, 120, 21, 200)
t15 = Environment(99, 255, 221, 1)
t16 = Environment(274, 200, 46, 55)
t17 = Environment(99, 120, 19, 135)
t18 = Environment(118, 120, 242, 10)
t19 = Environment(420, 120, 40, 200)
t20 = Environment(540, 120, 20, 180)
t21 = Environment(540, 300, 400, 20)
t22 = Environment(680, 200, 260, 40)
t23 = Environment(600, 120, 40, 121)
t24 = Environment(600, 120, 340, 20)
t25 = Environment(980, 20, 40, 201)
t26 = Environment(980, 221, 200, 12)
t27 = Environment(1062, 100, 37, 46)
t28 = Environment(1062, 146, 143, 13)
t29 = Environment(980, 300, 240, 19)
t30 = Environment(980, 300, 240, 19)
t31 = Environment(1205, 60, 15, 98)
t32 = Environment(616, 436, 143, 7)
t33 = Environment(558, 436, 25, 7)
t34 = Environment(540, 436, 18, 82)
t35 = Environment(715, 443, 44, 117)
t36 = Environment(135, 197, 57, 58)

def victory():
    global hearts
    if obj == 0:
        door = pygame.Rect(545, 562, 202, 117)
        pygame.draw.rect(WINDOW, 'blue' , door)
        if door.colliderect(player.x, player.y, player.width, player.height):
            print('yay you win!')
            running = False
            draw_win_menu()
        image = pygame.image.load("assets/hell.png").convert_alpha()
        image_width, image_height = image.get_size()
        WINDOW.blit(image, door)

# #sprite set up
class Character:
    def __init__(self, x, y, width, height, image):
        self.x = x
        self.y = y
        self.dx = 0
        self.dy = 0
        self.width = width
        self.height = height
        self.image = image
        self.rect = pygame.Rect(x, y, width, height)
    def draw(self):
        WINDOW.blit(pygame.transform.scale(self.image, (self.width, self.height)), (self.rect.x, self.rect.y))
    def draw(self):
        image = pygame.transform.scale(self.area[self.frames[self.frame]][self.direction], (self.width, self.height))
        self.change_direction() 
        image = pygame.transform.flip(image, self.turn, False)
        self.rect = image.get_rect()
        self.rect.center = (self.x, self.y)
        WINDOW.blit(image, (self.rect.center))
        if self.dx == 0 and self.dy == 0:
            self.frame = 0
            return   
        self.frame_timer += 1
        if self.frame_timer < ANIMATION_FRAME_RATE:
            return
        self.frame += 1
        if self.frame >= len(self.frames):
            self.frame = 0
        self.frame_timer = 0
    
    def update(self):
        self.x += self.dx
        self.y += self.dy
        self.draw()
        
class Player(Character):
    def __init__(self, x, y, width, height, area, speed):
        super().__init__(x, y, width, height, None)
        self.speed = speed
        self.area = load_area(area, 13, 20)
        self.direction = 0
        self.turn = False
        self.frame = 0
        self.frames = [0, 1, 0, 2]
        self.frame_timer = 0
        self.rect = pygame.Rect(x, y, width, height)
        
    def change_direction(self):
        if dx < 0:
            self.direction = HORIZONTAL
            self.turn = True
        elif dx > 0:
            self.direction = HORIZONTAL
            self.turn = False
        elif dy > 0:
            self.direction = DOWN
        elif dy < 0:
            self.direction = UP
    
    def draw(self):
        image = pygame.transform.scale(self.area[self.frames[self.frame]][self.direction], (self.width, self.height))
        self.change_direction()       
        image = pygame.transform.flip(image, self.turn, False)
        self.rect = image.get_rect()
        self.rect.center = (self.x, self.y)
        WINDOW.blit(image, (self.rect.center))
        if dx == 0 and dy == 0:
            self.frame = 0
            return
        self.frame_timer += 1
        if self.frame_timer < ANIMATION_FRAME_RATE:
            return
        self.frame += 1
        if self.frame >= len(self.frames):
            self.frame = 0
        self.frame_timer = 0
    def movement(self, dx, dy):
        if dx != 0 and dy != 0:
            dx = (dx * (math.sqrt(2) / 2)) * 0.75
            dy = (dy * (math.sqrt(2) / 2)) * 0.75
        self.x += dx * self.speed 
        self.y += dy * self.speed *0.75
        for env_rect in env_all:
            if env_rect.colliderect(self.x + dx, self.y, self.width, self.height):
                self.x = self.x - dx
            if env_rect.colliderect(self.x, self.y + dy, self.width, self.height):
                self.y = self.y - dy
    def update(self):
        self.movement(dx, dy)
        self.draw()

 
class Enemy(Character):
    def __init__(self, x, y, width, height, area, speed): 
        super().__init__(x, y, width, height, None)
        self.speed = speed
        self.area = load_area(area, 130,110)
        self.direction = 0
        self.turn = False
        self.frame = 0
        self.frames = [0, 1, 0, 2]
        self.frame_timer = 0
        self.rect = pygame.Rect(x, y, width, height)
    
    def change_direction(self):
        if self.dx < 0:
            self.direction = HORIZONTAL
            self.turn = False
        elif self.dx > 0:
            self.direction = HORIZONTAL
            self.turn = True
        elif self.dy > 0:
            self.direction = DOWN
        elif self.dy < 0:
            self.direction = UP
        if self.dy > self.dx > 0:
            self.direction = DOWN
        elif self.dy < self.dx < 0:
            self.direction = UP
         
    def update(self):
        
        self.dx = player.rect.x - enemy.rect.center[0]
        self.dy = player.rect.y - enemy.rect.center[1]
        
        
        magnitude = (self.dx ** 2 + self.dy ** 2) ** 0.5
        self.dx = (self.dx / magnitude * self.speed) * .8
        self.dy = self.dy / magnitude * self.speed
        if player.rect.colliderect(self.x, self.y, self.width, self.height):
            print("game over")
            draw_death_screen()
            
            
        
        self.draw()
        super().update()  
def load_area(filename, width, height):
    image = pygame.image.load(filename).convert_alpha()
    image_width, image_height = image.get_size()
    area = []
    for area_x in range(0, image_width // width):
        line = []
        area.append(line)
        for area_y in range(0, image_height // height):
            rect = (area_x * width, area_y * height, width, height)
            line.append(image.subsurface(rect))
    return area                   
player = Player(WINDOW_SIZE[0] // 2, WINDOW_SIZE[1] // 2, 20, 40, "assets/player_sheet.png", 1)
enemy = Enemy(730, 580, 80, 60, "assets/monster.png", 1)
#SCREEN SETUP
def draw_win_menu():
   WINDOW.fill((0, 0, 0))
   font = pygame.font.SysFont('arial', 60)
   title = font.render('"Congratulations! You Won! Or did you?"', True, (255, 255, 255))
#    start_button = font.render('Start', True, (255, 255, 255))
   WINDOW.blit(title, (WINDOW_SIZE[0]//2 - title.get_width()/2, WINDOW_SIZE[1]//2 - title.get_height()/2))
#    WINDOW.blit(start_button, (WINDOW_SIZE[0]//2 - start_button.get_width()/2, WINDOW_SIZE[1]//2 + start_button.get_height()/2))
   pygame.display.update()
   pygame.quit


def draw_death_screen():
   WINDOW.fill((0, 0, 0))
   font = pygame.font.SysFont('arial', 40)
   title = font.render('YOU DIED', True, (255, 255, 255))
   restart_button = font.render('R - Restart', True, (255, 255, 255))
   quit_button = font.render('Q - Quit', True, (255, 255, 255))
   WINDOW.blit(title, (WINDOW_SIZE[0]//2 - title.get_width()/2, WINDOW_SIZE[1]//2 - title.get_height()/3))
   WINDOW.blit(restart_button, (WINDOW_SIZE[0]//2 - restart_button.get_width()/2, WINDOW_SIZE[1]//1.9 + restart_button.get_height()))
   WINDOW.blit(quit_button, (WINDOW_SIZE[0]//2 - quit_button.get_width()/2, WINDOW_SIZE[1]//2 + quit_button.get_height()/2))
   pygame.display.update()
   pygame.quit()

key = Sprite(RED, 20, 30) 
key.rect.x = 1115
key.rect.y = 75
other = Sprite(RED, 20, 30) 
other.rect.x = 170
other.rect.y = 205
all_sprites_list = pygame.sprite.Group()
all_sprites_list.add(key, other)

def repel():
    global repels
    keys = pygame.key.get_pressed()
    if repels > 0:
        if keys[pygame.K_SPACE]:
            repels -=1
            enemy.x = 730
            enemy.y = 580
    
running = True
while running:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            quit()
           
            
    CLOCK.tick(60)

    # handle player movement
    dx = 0
    dy = 0
    if moving_right:
        dx = SPEED
    
    if moving_left:
        dx = -SPEED

    if moving_up:
        dy = -SPEED

    if moving_down:
        dy = SPEED

    player.movement(dx, dy)
    # draw the background and player
    WINDOW.blit(background, (0, 0))
    victory()
    player.update()
    enemy.update()
    
    
    all_sprites_list.update()  
    all_sprites_list.draw(WINDOW)
    repel()


    
    pygame.display.update()

    # handle events
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            sys.quit()
        elif event.type == pygame.KEYDOWN:
            if event.key == pygame.K_a:
                moving_left = True
            elif event.key == pygame.K_d:
                moving_right = True
            elif event.key == pygame.K_w:
                moving_up = True
            elif event.key == pygame.K_s:
                moving_down = True
        elif event.type == pygame.KEYUP:
            if event.key == pygame.K_a:
                moving_left = False
            elif event.key == pygame.K_d:
                moving_right = False
            elif event.key == pygame.K_w:
                moving_up = False
            elif event.key == pygame.K_s:
                moving_down = False
                

                    
